\documentclass{article}
\usepackage[utf8]{inputenc}
\usepackage[cm]{fullpage}
\usepackage{tikz}
\usepackage{tikz-qtree}
\usetikzlibrary{er, positioning}
\usepackage{float}
\floatstyle{boxed}
\restylefloat{figure or table}
\usepackage{graphicx}
\usepackage{subcaption}
\usepackage{hyperref}

\title{\textbf{Inventory System User Manual}}
\author{Steven Jackson, Spencer Warneke, Patrick Kranzpiller}
\date{4/17/2019}
\begin{document}
	\maketitle
	\begin{figure}[!htbp]
		\centering
		\includegraphics[width=.9\linewidth]{DocumentationCoverImage.PNG}
		\label{fig:COVER}
	\end{figure}
	\newpage
	\tableofcontents
	\newpage
	\section{Chapter 1	Database Management System}
		\subsection{Overall Design (User Interface)}
			\begin{figure}[!htbp]
				\centering
				\includegraphics[width=.8\linewidth]{OverallDesign.PNG}
				\caption{User Interface}
				\label{fig:UI}
			\end{figure}
			\subsubsection{File}
				\begin{itemize}
					\item \textbf{File$\rightarrow$Open...}
					\subitem Opens file explorer for user to load in a previously saved database.
					\item \textbf{File$\rightarrow$Export...}
					\subitem Opens file explorer for user to save the database as a JSON file.
					\item \textbf{File$\rightarrow$Publish...}
					\subitem Opens file explorer for user to select a database file to publish to the website.
					\item \textbf{File$\rightarrow$Fetch...}
					\subitem Open file explorer to save a downloaded database file from the web server.
					\item \textbf{File$\rightarrow$Exit}
					\subitem Safely closes the Database Management System.
				\end{itemize}
			\subsubsection{Tools}
				\begin{itemize}
					\item \textbf{Tools$\rightarrow$Add Entry}
					\subitem Add Entry will open a dialog which prompts the user to enter a enter new product information. This will be explained in more detail later in section \hyperref[sec:AddEdit]{\textbf{1.2.1 Add Product/Edit Product}}.
					\item \textbf{Tools$\rightarrow$Edit Entry}
					\subitem Edit Entry will open a dialog which prompts the user to edit information about a specific product. This option will only be selectable if a product in the inventory is highlighted. Left click while hovering over an entry to highlight it. This will be explained in more detail later in section \hyperref[sec:AddEdit]{\textbf{1.2.1 Add Product/Edit Product}}.
					\item \textbf{Tools$\rightarrow$Remove Entry}
					\subitem Remove Entry will remove the selected inventory entry from the database. This option will only be selectable if a product in the inventory is highlighted. Left click while hovering over an entry to highlight it.
				\end{itemize}
			\subsubsection{Filtering}
				Filtering will allow the user to reduce the amout of inventory entries being displayed on the screen. This is most useful when wanting to display only a specific type of inventory entry. The user can filter by classification present within the tags attribute of the entries. Below the \textbf{File} and \textbf{Tools} menu options you will see tabs labeled \textbf{Laptops}, \textbf{Desktops}, \textbf{Cables}, etc. By selecting a tab the Database Management System will filter database entries only showing the entries which contain the tag matching the selected tab. The \textbf{All} tab will display all entries within the database.
			\subsubsection{Sorting}
				Sorting will allow the user to change the order in which products on the current tab are displayed. The two options available for each attribute. Depending on the attribute data, these are alphabetical or reverse-alphabetical, and numerically-ascending or numerically-descending. To toggle between these two option select a column header located just above the entries. These attribute headers are labeled as such; \textbf{Name}, \textbf{Specifications}, \textbf{Tags}, \textbf{Cost}, \textbf{Quantity}, and \textbf{Image}.
		\subsection{Use Cases}
			\subsubsection{Add Product/Edit Product}
			\label{sec:AddEdit}
				\begin{figure}[!ht]
					\centering
					\begin{subfigure}[!bp]{0.48\linewidth}
						\includegraphics[scale=.45]{AddEntry.PNG}
						\caption{Add Entry}
					\end{subfigure}
					\begin{subfigure}[!bp]{0.48\linewidth}
						\includegraphics[scale=.45]{EditEntry.PNG}
						\caption{Edit Entry}
					\end{subfigure}
					\label{fig:AEEE}
				\end{figure}
				Add Entry and Edit Entry will bring up the same dialog which is why we can talk about them at the same time. The only difference being that Add Entry will insert the new data into the inventory system and Edit Entry will change allow the user to change data about a specific entry. There are several fields for data entry, all of which correspond to an attribute header on the product display page. Now we can speak about the fields on an individual basis.
				\begin{itemize}
					\item \textbf{Name}
					\subitem Name will need to be something unique to each entry in the inventory system. This is often recommended to be a manufacturer name with a product name and possibly followed by a model number. Again the important note is that this is unique to each entry, because this is what allows the user to differentiate between products in the inventory system.
					\item \textbf{Specifications}
					\subitem Specifications will the details about the specific product. For example, a Desktop product entry should contain information about what individual parts were used to build the Desktop. Information such as GPU, CPU, RAM, and HDD/SSD should be listed here. Specifications in this field should be separated by single Return as shown in figure (b) Edit Entry above.
					\item \textbf{Tags}
					\subitem Tags are important for the filter feature. These will allow the Database Management System to display a subset of all inventory system entries. Currently the only valid Tags are; \textbf{Desktop}, \textbf{Laptop}, and \textbf{Cables}. Additional valid Tags may be created over the lifetime of this software. Just like Specifications, Tags if this field should be separated by a single Return as show in figure (b) Edit Entry above.
					\item \textbf{Cost}
					\subitem The Cost field is where the user stores the selling price of the specific product. No automatic formatting will be done to this field, so make sure to include cents within the number as shown in figure (b) Edit Entry above.
					\item \textbf{Quantity}
					\subitem Quantity is where the user stores how many of the specific product are in stock.
					\item \textbf{Image}
					\subitem Image consists of two fields in the Add Entry and Edit Entry dialogs. This is to give the user options to adding an image to the specific product. A radial button to the left of each field will show the selected field to be used when the done adding or editing a product. The \textbf{Local Image} field is for adding an image from your local machine. To make adding a local image path easier use the \textbf{Browse} button to the right of the image field. The \textbf{Browse} button will open a file explorer for the user to find the image within the file directory system. When using \textbf{By URL} field simply copy the URL of an image and paste it into the field. With either filed ensure that the corresponding radial button is selected before pressing \textbf{OK}.
					\item \textbf{OK}
					\subitem Use the \textbf{OK} button when all the information in the \textbf{Add Entry} or \textbf{Edit Entry} dialog is correct and ready to be inserted into the inventory database.
					\item \textbf{Cancel}
					\subitem \textbf{Cancel} will close the \textbf{Add Entry} or \textbf{Edit Entry} dialog without saving any changes. For \textbf{Add Entry}, \textbf{Cancel} will not add the product to the database, and all data entered will be lost. For \textbf{Edit Entry}, \textbf{Cancel} will discard any changes made to the specific product.
				\end{itemize} 
			\subsubsection{Remove Product}
				\textbf{Remove Product} will remove the selected product from the inventory database. There will be no way to recover this entry once removed. To select a product to remove from the inventory database, hover the mouse pointer over the entry you wish to select and use the mouse left click. When an entry is selected the row of data corresponding to the entry will appear highlighted in blue.
			\subsubsection{Open}
				\textbf{Load} will open the file explorer giving the user choice of which database file to load into the Database Management System. Currently two file formats will be accepted, JSON, and DBS.
			\subsubsection{Export}
				\textbf{Export} will open the file explorer giving the user choice where to save the database file. The database file will be saved in JSON format.
			\subsubsection{Publish}
				\textbf{Publish} will open the file explorer dialog allowing the user to select an exported database file to publish to the website. As an added feature, the Database Management System will recognize when the database file selected isn't the most current version. When this occurs a warning message will appear notifying the user that a database file which isn't the most current is selected, and ask the user if this is the intended database file to be published.
			\subsubsection{Fetch}
				\textbf{Fetch} will open a file explorer giving the user choice where to save a downloaded database file along with the file name. \textbf{Fetch} will then retrieve the database file from the web server and save it in the chosen path with the selected name. After retrieving the file and saving it, the Database Management System will ask the user if they would like to open the newly saved database file.
\end{document}